PUB Init(pv_DataStart)                                      
  CogNew(@__INIT, pv_DataStart)                             
                                                            
DAT                                                         
  ORG 0                                                     
__INIT                                                      
                mov         dira,__InitDirA                 
                mov         outa,__InitOutA                 

'   addr      VAR LONG ' Holds hub address of video memory being displayed '  addr      VAR LONG ' Holds hub address of video memory being displayed

'   line      VAR LONG ' Holds vertical line being generated '  line      VAR LONG ' Holds vertical line being generated

'   segment   VAR LONG ' Counts longs for each horizonal line '  segment   VAR LONG ' Counts longs for each horizonal line

'   pixels    VAR LONG ' Holds pixels being displayed        '  pixels    VAR LONG ' Holds pixels being displayed

'   lineTimer VAR LONG ' Used to generate each line every 64uSec '  lineTimer VAR LONG ' Used to generate each line every 64uSec


'   SyncPin  PIN 12 OUTPUT ' Sync signal on pin 12 (Demo board) '  SyncPin  PIN 12 OUTPUT ' Sync signal on pin 12 (Demo board)

'   VideoPin PIN 14 OUTPUT ' Video (black / white) signal on pin 14 (Demo board) '  VideoPin PIN 14 OUTPUT ' Video (black / white) signal on pin 14 (Demo board)


                                                             '  ' Setup cnta to use video hardware
                mov         CTRA,_125829120                  '  CTRA = %0_00001_111_00000000_000000_000_000000   ' Video PLL x16

                mov         FRQA,_429496729                  '  FRQA = $1999_9999   ' = 8 Mhz FROM 80Mhz clock x 16PLL = 128MHz


                                                             '  ' Setup VSCL
                mov         VSCL,_90816                      '  VSCL = $16_2C0      ' Pixel clock = 128MHz / 22 = 5.818181MHz


                                                             '  ' Setup I/O pins
                or          dira,SyncPin                     '  LOW SyncPin
                andn        outa,SyncPin                    

                or          dira,VideoPin                    '  LOW VideoPin
                andn        outa,VideoPin                   


                                                             '  ' Setup for initial state
                mov         line,#0                          '  line = 0

                mov         addr,#vidMem_ofs                 '  GetAddr VidMem, addr
                add         addr,par                        

                mov         lineTimer,CNT                    '  lineTimer = CNT + 5120
                adds        lineTimer,_5120                 

__DO_2                                                       '  DO

                waitcnt     lineTimer,#376                   '    WaitCnt LineTimer,376 ' 4.7USec for Sync

                andn        OUTA,SyncPin                     '    SyncPin = 0

                waitcnt     lineTimer,_4744                  '    WaitCnt LineTimer,4744 ' Totoal of 5120 clocks @ 80MHz = 64uSec per line

                                                             '    ' Line 0-2 = Sync; 3-36= Top Blank; 37-228 = Pixels; 229-261 = Bottom Blank
                cmps        line,#3 WZ, WC                   '    IF line > 3 THEN
    IF_BE       jmp         #__ELSE_5                       

                or          OUTA,SyncPin                     '      SyncPin = 1

                mov         __temp1,cnt                      '      PAUSEUS 3 ' Left Margin
                adds        __temp1,#80                     
                mov         __temp2,#3                      
__L0003                                                     
                waitcnt     __temp1,#80                     
                djnz        __temp2,#__L0003                

                cmps        line,#36 WZ, WC                  '      IF line > 36 THEN
    IF_BE       jmp         #__ELSE_6                       

                cmps        line,#229 WZ, WC                 '        IF line < 229 THEN
    IF_AE       jmp         #__ELSE_7                       

                                                             '          ' Setup VCFG to send one line of pixels
                mov         VCFG,_536871488                  '          VCFG = %0_01_0_0_0_000_00000000000_001_0_0100_0000

                mov         segment,#0                       '          FOR segment = 0 TO  7 '8 * 32 = 256 pixels per line
__FOR_segment_1                                             

                rdlong      pixels,addr                      '            RdLong addr, pixels

                waitvid     _65280,pixels                    '            WaitVid $FF00, pixels

                adds        addr,#4                          '            addr = addr + 4

                adds        segment,#1                       '          NEXT
                cmps        segment,#7 WZ, WC               
    IF_BE       jmp         #__FOR_segment_1                

                                                             '          ' Stop generating pixels
                mov         __temp1,#0                       '          WaitVid 0,0
                waitvid     __temp1,#0                      

                mov         VCFG,#0                          '          VCFG = 0

__ELSE_7                                                     '        ENDIF
__ENDIF_7                                                   

__ELSE_6                                                     '      ENDIF
__ENDIF_6                                                   

__ELSE_5                                                     '    ENDIF
__ENDIF_5                                                   

                adds        line,#1                          '    INC line

                cmps        line,#262 WZ, WC                 '    IF line = 262 THEN
    IF_NZ       jmp         #__ELSE_8                       

                                                             '      ' Reset for new frame
                mov         line,#0                          '      line = 0

                mov         addr,#vidMem_ofs                 '      GetAddr VidMem, addr
                add         addr,par                        

__ELSE_8                                                     '    ENDIF
__ENDIF_8                                                   

                jmp         #__DO_2                          '  LOOP
__LOOP_2                                                    

'**********************************************************************
__InitDirA       LONG %00000000_00000000_01010000_00000000
__InitOutA       LONG %00000000_00000000_00000000_00000000
SyncPin          LONG 4096
_4744            LONG 4744
_5120            LONG 5120
VideoPin         LONG 16384
_65280           LONG 65280
_90816           LONG 90816
_125829120       LONG 125829120
_429496729       LONG 429496729
_536871488       LONG 536871488

__REMAINDER
__TEMP1          RES 1
__TEMP2          RES 1
__TEMP3          RES 1
__TEMP4          RES 1
__TEMP5          RES 1
__PARAM1         RES 1
__PARAM2         RES 1
__PARAM3         RES 1
__PARAM4         RES 1
__PARAMCNT       RES 1
addr             RES 1
line             RES 1
segment          RES 1
pixels           RES 1
lineTimer        RES 1

FIT 492

CON
  LSBFIRST                         = 0
  MSBFIRST                         = 1
  MSBPRE                           = 0
  LSBPRE                           = 1
  MSBPOST                          = 2
  LSBPOST                          = 3
  vidMem_ofs                       = 0
